/* Andrei Parvu
   O(N) */

#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <vector>

using namespace std;

#define NMAX 250000

int pi[NMAX + 5], cost[NMAX + 5], sir[NMAX + 5];
long long sol[NMAX + 5], d[NMAX + 5];
int n, teste;
vector<int> v[NMAX + 5];

void prefix() {
  int x = 0, i;

  v[0].push_back(1);

  for (i = 2; i <= n; i ++) {
    for (; x > 0 && sir[i] != sir[x + 1]; x = pi[x]);

    if (sir[i] == sir[x + 1]) {
      x ++;
    }

    pi[i] = x;
    v[x].push_back(i);
  }
}

void df(int nod) {
  int i;

  d[nod] = cost[nod];

  for (i = 0; i < (int)v[nod].size(); i ++) {
    df(v[nod][i]);

    d[nod] += d[v[nod][i]];
  }

  sol[nod] = d[nod];
}

int main() {
  freopen("zlego.in", "rt", stdin);
  freopen("zlego.out", "wt", stdout);

  assert(scanf("%d", &teste));

  assert(1 <= teste && teste <= 3);

  for (; teste--; ) {
    assert(scanf("%d", &n));
    assert(1 <= n && n <= NMAX);

    for (int i = 1; i <= n; i ++) {
      v[i].clear();
    }

    for (int i = 1; i <= n; i ++) {
      assert(scanf("%d", &sir[i]));
    }

    for (int i = 1; i <= n; i ++) {
      assert(scanf("%d", &cost[i]));
    }

    prefix();

    df(0);

    for (int i = 1; i <= n; i ++) {
      printf("%lld\n", sol[i]);
    }
  }

  return 0;
}

